module questao2a(

	input logic x,
	input logic b0,
	input logic b1,
	input logic b2,
	input logic b3,
	input logic clk,
	output logic [1..0] y

);

logic r1,r2,r3;
logic [1..0] m1,m2,m3,m4;
logic [1..0] s1,s2;

always_ff @(posedge clk) begin

	r1 <= x;
	r2 <= r1;
	r3 <= r2;
	m1 <= x * b0;
	m2 <= r1 * b1; 
	m3 <= r2 * b2;
	m4 <= r3 * b3;
	s1 <=  m1 + m2;
	s2 <= s1 + m3;
	y <=  s2 + m4;
	
end

endmodule 