module questao1c(

	input logic [7:0] x,c0,c1,c2,c3,
	input logic clk,
	output logic [15:0] y

);

reg [15:0] r1, r2,r3;
logic [15:0] s1,s2;

always_ff @(posedge clk) begin

	r1 <= x * c3;
	r2 <= s1;
	r3 <= s2;
	
end

always_comb begin

	s1 <= r1 + (c2 * x);
	s2 <= r2 + (c1 * x);
	y <= r3 + (c0 * x);
	
end

endmodule 