module questao3c(

	input logic x1,
	input logic x2,
	input logic x3,
	input logic x4,
	input logic x5,
	input logic x6,
	input logic x7,
	input logic x8,
	input logic clk,
	output logic [3:0] y

);

reg r1, r2, r3, r4, r5, r6, r7, r8;
reg r9, r10, r11, r12, r13, r14, r15, r16;
reg r17, r18, r19, r20, r21, r22, r23, r24;
reg r25, r26, r27, r28, r29;
logic s1,c1,s2,c2,s3,c3,s4;

always_ff @(posedge clk) begin

	r1 <= x8;
	r2 <= x7;
	r3 <= x6;
	r4 <= x5;
	r5 <= x4;
	r6 <= x3;
	r7 <= x2;
	r8 <= x1;
	
	r9 <= r1;
	r10 <= r2;
	r11 <= r3;
	r12 <= r4;
	r13 <= r5;
	r14 <= r6;
	r15 <= c1;
	r16 <= s1;
	
	r17 <= r9;
	r18 <= r10;
	r19 <= r11;
	r20 <= r12;
	r21 <= c2;
	r22 <= s2;
	r23 <= r16;
	
	r24 <= r17;
	r25 <= r18;
	r26 <= c3;
	r27 <= s3;
	r28 <= r22;
	r29 <= r23;
	
	
end

always_comb begin

	s1 <= r7 + r8;
	c1 <= r7 * r8;
	s2 <= r13 + r14 + c1;
	c2 <= (r13 * r14) + (r13 * c1) + (r14 * c1);
	s3 <= r19 + r20 + c2;
	c3 <= (r19 * r20) + (r19 * c2) + (r20 * c2);
	s4 <= r24 + r25 + c3;
	
	y[0] <= r29;
	y[1] <= r28;
	y[2] <= r27;
	y[3] <= s4;

end

endmodule 