module questao5a(

input logic clk,
input logic [3:0] x, a,
input logic [7:0] a2,
input logic [15:0] a4,
output logic [31:0] y
);

reg [3:0] r1;
reg [7:0] r2, r3;
reg [15:0] r4,r5,r6,r7;
logic [7:0] m1, s1;
logic [15:0] m2, s2;
logic [31:0] m3, s3;

always_ff @ (posedge clk) begin

	r1 <= x;
	r2 <= s1;
	r3 <= r2;
	r4 <= s3;
	r5 <= r4;
	r6 <= r5;
	r7 <= r6;

end

always_comb begin

	m1 <= a * r1;
	s1 <= m1 + x;
	m2 <= a2 * r3;
	s2 <= m2 + s1;
	s3 <= m3 + s2;
	m3 <= r7 * a4; 
	y <= s3;


end

endmodule 