module questao1b(

	input logic [7:0] x,c0,c1,c2,c3,
	input logic clk,
	output logic [15:0] y

);

reg [7:0] r1, r2,r3;
logic [15:0] s1,s2;

always_ff @(posedge clk) begin

	r1 <= x;
	r2 <= r1;
	r3 <= r2;
	
end

always_comb begin

	s1 = (c3*r3) + (c2*r2);
	s2 = s1 + (c1*r1);
	y = (c0*x) + s2;

end

endmodule 