module questao1d(

	input logic [7:0] x,c0,c1,c2,c3,
	input logic clk,
	output logic [15:0] y

);

reg [15:0] r1,r2,r3,r4,r5,r6,r7;
logic [15:0] s1,s2;

always_ff @(posedge clk) begin

	r1 <= c3 * x;
	r2 <= r1;
	r3 <= c2 * x;
	r4 <= s1;
	r5 <= c1 * x;
	r6 <= s2;
	r7 <= c0 * x;
	
end

always_comb begin

	s1 <= r2 + r3;
	s2 <= r4 + r5;
	y <= r7 + r6;

end

endmodule 