module questao2a(

	input logic [7:0] x,b0,b1,b2,b3,
	input logic clk,
	output logic [15:0] y

);

reg [7:0] r1,r2,r3;
logic [15:0] m1,m2,m3,m4,s1,s2;

always_ff @(posedge clk) begin

	r1 <= x;
	r2 <= r1;
	r3 <= r2;
	
end

always_comb begin

	m1 <= b0 * x;
	m2 <= b1 * r1;
	m3 <= b2 * r2;
	m4 <= b3 * r3;
	s1 <= m1 + m2;
	s2 <= m3 + s1;
	y <= m4 + s2;

end

endmodule 