module questao2b (
	input logic [7:0] x,b0,b1,b2,b3,
	input logic clk,
	output logic [15:0] y
);

reg [7:0] r1, r2, r3;
reg [15:0] racumulator, routput;
logic [1:0] seletor, lut, rindex;
logic [7:0] saida_sel, saida_lut;
logic [15:0] m1, s1;

always_comb begin
	
	case(seletor)
		0: saida_sel <= x;
		1: saida_sel <= r1;
		2: saida_sel <= r2;
		3: saida_sel <= r3;
	endcase
	
	case(lut)
		0: saida_lut <= b0;
		1: saida_lut <= b1;
		2: saida_lut <= b2;
		3: saida_lut <= b3;
	endcase
	
	seletor <= rindex;
	lut <= rindex;	
	
	m1 <= saida_sel * saida_lut;
	s1 <= m1 + racumulator;
	y <= routput;
	
end	


always_ff @(posedge clk) begin

	r1 <= x;
	r2 <= r1;
	r3 <= r2;
	rindex <= (rindex + 1) % 4; 
	racumulator <= s1;
	routput <= s1;

end

endmodule 