module questao3d (

	input logic x1, x2,
	input logic clk,
	output logic [1:0] y
);

reg r1;
logic [1:0] s1;
logic c1;

always_ff@(posedge clk) begin

	r1 <= c1;
end

always_comb begin

	s1 <= x1 + x2 + r1;
	c1 = (x1 * x2) + (x1 * r1) + (x2 * r1);
	y <= s1;

end

endmodule
